曲径通幽处,禅房花木深—-bash禅意脚本

编程基础

程序:指令+数据

程序编程风格:

  1. 过程式:以指令为中心,数据服务于指令

  2. 对象式:以数据为中心,指令服务于数据

  3. shell程序:提供了编程能力,解释执行

编程基本概念

编程逻辑处理方式:

  1. 顺序执行

  2. 循环执行

  3. 选择执行

shell编程:过程式、解释执行

编程语言的基本结构:

数据存储:变量、数组

表达式: a + b

语句:if

shell脚本基础

shell脚本是包含一些命令或声明,并符合一定格式的文

本文件

格式要求:首行shebang机制

  • #!/bin/bash

  • #!/usr/bin/python

  • #!/usr/bin/perl

shell脚本的用途有:

  1.  自动化常用命令

  2.  执行系统管理和故障排除

  3.  创建简单的应用程序

  4.  处理文本或文件

创建shell脚本

第一步:使用文本编辑器来创建文本文件

 第一行必须包括shell声明序列: #!

 #!/bin/bash

 添加注释

注释以#开头

第二步:运行脚本

 给予执行权限,在命令行上指定脚本的绝对或相对路径

 直接运行解释器,将脚本作为解释器程序的参数运行

shell脚本范例

1
2
3
4
5
6
7

#!/bin/bash
#author: wang
#Version: 1.0
#Description:This script displays some informationabout your
# environment
echo "Greetings. The date and time are $(date)"
echo "Your working directory is: $(pwd)"

脚本调试

bash -n /path/to/some_script

检测脚本中的语法错误

bash -x /path/to/some_script

调试执行

变量

变量:命名的内存空间

数据存储方式:

字符:

数值:整型,浮点型

变量:变量类型

作用:

1、数据存储格式

2、参与的运算

3、表示的数据范围

类型:

字符

数值:整型、浮点型

编程程序语言分类

强类型:定义变量时必须指定类型、参与运算必须符合类型要求;调用未声明变量会产生错误,如 java,python

弱类型:无须指定类型,默认均为字符型;参与运算会自动

进行隐式类型转换;变量无须事先定义可直接调用;如: bash 不支持浮点数

变量命名法则:

1、不能使程序中的保留字:例如if, for;

2、只能使用数字、字母及下划线,且不能以数字开头

3、见名知义

4、统一命名规则:驼峰命名法

bash中变量的种类

  • 根据变量的生效范围等标准:

  • 本地变量:生效范围为当前shell进程;对当前shell之外的其它shell进程,包括当前shell的子shell进程均无效

  • 环境变量:生效范围为当前shell进程及其子进程

  • 局部变量:生效范围为当前shell进程中某代码片断(通常指函数)

  • 位置变量: $1, $2, …来表示,用于让脚本在脚本代码中调用通过命令行传递给它的参数

  • 特殊变量: $?, $0, $*, $@, $#

本地变量

变量赋值: name=‘value’,

可以使用引用value:

(1) 可以是直接字串; name=“root”

(2) 变量引用: name=”$USER”

(3) 命令引用: name=`COMMAND`, name=$(COMMAND)

变量引用: ${name}, $name

“”:弱引用,其中的变量引用会被替换为变量值

”:强引用,其中的变量引用不会被替换为变量值,而保持原字符串

显示已定义的所有变量: set

删除变量: unset name

练习

1、编写脚本/root/bin/systeminfo.sh,显示当前主机系统信息,包括主机名, IPv4地址,操作系统版本,内核版本,CPU型号,内存大小,硬盘大小。

1
2
3
4
5
6
7
8
9
10
11
12
13
14

#!/bin/bash
HostName=`hostname`
IP1=`ifconfig | sed -n '2p' | tr -s " " | cut -d" " -f3    `
OSversion=`lsb_release -d | tr -s " " | cut -d: -f2`
CPUinfo=`cat /proc/cpuinfo | grep 'model name'| tr -s "     " | cut -d: -f2`
KernelV=`uname -r`
MemInfo=`cat /proc/meminfo | grep 'MemTotal'`
DiskInfo=`fdisk -l | sed -n '2p' | cut -d" " -f3,4`
echo "Hostname : $HostName "
echo "IP : $IP1 "
echo "OS Version : $OSversion "
echo "CPU : $CPUinfo "
echo "Kernel : $KernelV"
echo "Disk : $DiskInfo"

201608111930001

2、编写脚本/root/bin/backup.sh,可实现每日将/etc/目录备份到/root/etcYYYY-mm-dd中

201608111931001

3、编写脚本/root/bin/disk.sh,显示当前硬盘分区中空间利用率最大的值

201608111937001

4、编写脚本/root/bin/links.sh,显示正连接本主机的每个远程主机的IPv4地址和连接数,并按连接数从大到小排序

 201608111959001

环境变量

变量声明、赋值:

export name=VALUE

declare -x name=VALUE

变量引用: $name, ${name}

显示所有环境变量:

export

env

printenv

删除: unset name

bash有许多内建的环境变量: PATH, SHELL, USRE,UID,

HISTSIZE, HOME, PWD, OLDPWD, HISTFILE, PS1

只读和位置变量

只读变量:只能引用,但不能修改和删除

readonly name

declare -r name

位置变量:在脚本代码中调用通过命令行传递给脚本的参数

  • $1, $2, …:对应第1、第2等参数, shift [n]换位置

  • $0: 命令本身

  • $*: 传递给脚本的所有参数,全部参数合为一个字符串(可参考为python中的字符串)

  • $@: 传递给脚本的所有参数,每个参数为独立字符串(可参考为python中的列表,保持其独立性)

  • $#: 传递给脚本的参数的个数

  • $@ $* 只在被双引号包起来的时候才会有差异

示例:判断给出的文件的行数

linecount=”$(wc -l $1| cut -d’ ‘ -f1)”

echo “$1 has $linecount lines.”

算术运算

bash中的算术运算:help let

+, -, *, /, %取模(取余) , **(乘方)

实现算术运算:

(1) let var=算术表达式

(2) var=$[算术表达式]

(3) var=$((算术表达式))

(4) var=$(expr arg1 arg2 arg3 …)

(5) declare –i var = 数值

(6) echo ‘算术表达式’ | bc

乘法符号有些场景中需要转义, 如*

bash有内建的随机数生成器: $RANDOM( 1-32767)

echo $[$RANDOM%50] : 0-49之间随机数

赋值

增强型赋值:

+=, -=, *=, /=, %=

let varOPERvalue

例如:let count+=3

自加3后自赋值

自增,自减:

let var+=1

let var++

let var-=1

let var–

export 在进行乘法运算的时候,*需要转义

练习

练习1:写一个脚本/root/bin/sumid.sh,计算/etc/passwd文件中的第10个用户和第20用户的ID之和

201608112002001

练习2:写一个脚本/root/bin/sumspace.sh,传递两个文件路径作为参数给脚本,计算这两个文件中所有空白行之和

201608112003001

练习3:写一个脚本/root/bin/sumfile.sh,统计/etc, /var,/usr目录中共有多少个一级子目录和文件

201608112004001

逻辑运算

true, false

1, 0

与:

1 与 1 = 1

1 与 0 = 0

0 与 1 = 0

0 与 0 = 0

或:

1 或 1 = 1

1 或 0 = 1

0 或 1 = 1

0 或 0 = 0

逻辑运算

非:!

! 1 = 0

! 0 = 1

短路运算:

短路与:

第一个为0,结果必定为0;

第一个为1,第二个必须要参与运算;

短路或:

第一个为1,结果必定为1;

第一个为0,第二个必须要参与运算;

异或: ^

异或的两个值,相同为假,不同为真

聚集命令

有两种聚集命令的方法:

• 复合式: date; who | wc -l

命令会一个接一个地运行

• 子shell: (date; who | wc -l ) >>/tmp/trace

所有的输出都被发送给单个STDOUT和STDERR

退出状态

进程使用退出状态来报告成功或失败

• 0 代表成功, 1-255代表失败

• $? 变量保存最近的命令退出状态

例如:

  1. $ ping -c1 -W1 hostdown &> /dev/null

  2. $ echo $?

退出状态码

bash自定义退出状态码

exit [n]:自定义退出状态码;

注意:脚本中一旦遇到exit命令,脚本会立即终止;终止退出状态取决于exit命令后面的数字

注意:如果未给脚本指定退出状态码,整个脚本的退出状态码取决于脚本中执行的最后一条命令的状态码

条件测试

判断某需求是否满足,需要由测试机制来实现;

专用的测试表达式需要由测试命令辅助完成测试过程;

评估布尔声明,以便用在条件性执行中

• 若真,则返回0

• 若假,则返回1

测试命令:

• test EXPRESSION

• [ EXPRESSION ]

• [[ EXPRESSION ]]

注意: EXPRESSION前后必须有空白字符

条件性的执行操作符

根据退出状态而定,命令可以有条件地运行

• && 代表条件性的AND THEN

• || 代表条件性的OR ELSE

例如:

$ grep -q no_such_user /etc/passwd \

|| echo ‘No such user’

No such user

$ ping -c1 -W2 station1 &> /dev/null \

> && echo “station1 is up” \

> || (echo ‘station1 is unreachable’; exit 1)

station1 is up

test命令

长格式的例子:

$ test “$A” == “$B” && echo “Strings are equal”

$ test “$A” -eq “$B” \

&& echo “Integers are equal”

简写格式的例子:

$ [ “$A” == “$B” ] && echo “Strings are equal”

$ [ “$A” -eq “$B” ] && echo “Integers are equal”

bash的测试类型

数值测试:

  • -gt: 是否大于;

  • -ge: 是否大于等于;

  • -eq: 是否等于;

  • -ne: 是否不等于;

  • -lt: 是否小于;

  • -le: 是否小于等于;

bash的测试类型

字符串测试:

  • ==:是否等于;

  • >: ascii码是否大于ascii码

  • <: 是否小于

  • !=: 是否不等于

  • =~: 左侧字符串是否能够被右侧的PATTERN所匹配

注意: 此表达式一般用于[[ ]]中;

  • -z “STRING”:字符串是否为空,空为真,不空为假

  • -n “STRING”:字符串是否不空,不空为真,空为假

注意:用于字符串比较时的用到的操作数都应该使用引号

练习

1、写一个脚本/root/bin/argsnum.sh,接受一个文件路径作为参数;如果参数个数小于1,则提示用户“至少应该给一个参数”,并立即退出;如果参数个数不小于1,则显示第一个参数所指向的文件中的空白行数

201608112007001

2、写一个脚本/root/bin/hostping.sh,接受一个主机的IPv4地址做为参数,测试是否可连通。如果能ping通,则提示用户“该IP地址可访问”;如果不可ping通,则提示用户“该IP地址不可访问”

201608112028001

3,写个脚本查看磁盘利用率最高的,并且判断最大值是否大于80%,是则报警

201608112033001

文件测试

存在性测试

  • -a FILE:同-e

  • -e FILE: 文件存在性测试,存在为真,否则为假;

存在性及类别测试

  • -b FILE:是否存在且为块设备文件;

  • -c FILE:是否存在且为字符设备文件;

  • -d FILE:是否存在且为目录文件;

  • -f FILE:是否存在且为普通文件;

  • -h FILE 或 -L FILE:存在且为符号链接文件;

  • -p FILE:是否存在且为命名管道文件;

  • -S FILE:是否存在且为套接字文件;

文件测试

文件权限测试:

  • -r FILE:是否存在且可读

  • -w FILE: 是否存在且可写

  • -x FILE: 是否存在且可执行

文件特殊权限测试:

  • -g FILE:是否存在且拥有sgid权限;

  • -u FILE:是否存在且拥有suid权限;

  • -k FILE:是否存在且拥有sticky权限;

文件测试

文件大小测试:

  • -s FILE: 是否存在且非空;

文件是否打开:

  • -t fd: fd表示文件描述符是否已经打开且与某终端相关

  • -N FILE:文件自动上一次被读取之后是否被修改过

  • -O FILE:当前有效用户是否为文件属主

  • -G FILE:当前有效用户是否为文件属组

文件测试

双目测试:

FILE1 -ef FILE2: FILE1与FILE2是否指向同一个设

备上的相同inode

FILE1 -nt FILE2: FILE1是否新于FILE2;

FILE1 -ot FILE2: FILE1是否旧于FILE2;

组合测试条件

第一种方式:

  • COMMAND1 && COMMAND2 并且

  • COMMAND1 || COMMAND2 或者

  • ! COMMAND 非

如: [ -e FILE ] && [ -r FILE ]

第二种方式:

EXPRESSION1 -a EXPRESSION2 并且

EXPRESSION1 -o EXPRESSION2 或者

! EXPRESSION

必须使用测试命令进行;

# [ -z “$HOSTNAME” -o $HOSTNAME “==\

“localhost.localdomain” ] && hostname www.magedu.com

# [ -f /bin/cat -a -x /bin/cat ] && cat /etc/fstab

练习

1、 chmod -rw /tmp/file1,编写脚本/root/bin/per.sh,判断当前用户对/tmp/fiile1文件 是否不可读且不可写

201608112039001

2、编写脚本/root/bin/nologin.sh和login.sh,实现禁止和充许普通用户登录系统。

201608112048001201608112102001计算1+2+3+…+100的值

201608112116001
计算从脚本第一参数A开始,到第二个参数B的所有数字的总和,判断B是否大于A,否提示错误并退出,是则计算之

201608112135001

原创文章,作者:M20-石俊,如若转载,请注明出处:http://www.178linux.com/33691

(0)
上一篇 2016-08-12 09:01
下一篇 2016-08-12 09:01

相关推荐

  • Leetcode 编程训练

    Leetcode这个网站上的题都是一些经典的公司用来面试应聘者的面试题,很多人通过刷这些题来应聘一些喜欢面试算法的公司,比如:Google、微软、Facebook、Amazon之类的这些公司,基本上是应试教育的功利主义。 我做这些题目的不是为了要去应聘这些公司,而是为了锻炼一下自己的算法和编程能力。因为我开始工作的时候基本没有这样的训练算法和编程的网站,除了…

    Linux干货 2016-08-15
  • 文本处理三剑客之grep及正则表达式

    文本处理三剑客之grep及正则表达式   文本处理工具:   Linux上处理文本三剑客:     Grep:文本过滤器工具(模式:pattern)工具;     Sed: stream editor,流编辑器;文本编辑工具;   &nbs…

    Linux干货 2016-08-12
  • LVS类型及其调度算法

    LVS类型:     NAT:–>(DNAT) (多目标的DNAT)     DR:     TUN:     FULLNAT: LVS NAT的特性  &nbs…

    Linux干货 2016-10-29
  • N22第六周作业

    VIM编辑器介绍 什么是VIM? Vim是一个类似于Vi的著名的功能强大、高度可定制的文本编辑器,在Vi的基础上改进和增加了很多特性。VIM是纯粹的自由软件。 Vim是从 vi 发展出来的一个文本编辑器。代码补全、编译及错误跳转等方便编程的功能特别丰富,在程序员中被广泛使用,和Emacs并列成为类Unix系统用户最喜欢的文本编辑器。 VIM的使用 &nbsp…

    Linux干货 2016-10-24
  • 94-varnish

        一. Web Page Cache 相关概念

    2016-11-18
  • hadoop分布式集群

    分布式集群的实现 环境: 192.168.36.129   node1:NN,SNN,RM  192.168.36.130  node2:DN,NM 192.168.36.132   node3:DN,NM 192.168.36.133   node4:DN,NM 配置java环境,每个节点时间同步,基于主机名互相通信,定义/etc/hosts 文件 &nb…

    2017-12-09

评论列表(1条)

  • 马哥教育
    马哥教育 2016-08-16 15:13

    态度端正,图文并貌题目立意很诗意哦,望后期再接再厉呢。